#include "../../src/Battling/Library/DamageLibrary.hpp"
#include "../Core.hpp"
using namespace CreatureLib::Battling;

export const DamageLibrary* CreatureLib_DamageLibrary_Construct() { return new DamageLibrary(); }

export void CreatureLib_DamageLibrary_Destruct(const DamageLibrary* p) { delete p; }

export u8 CreatureLib_DamageLibrary_GetDamage(u32& out, const DamageLibrary* p, ExecutingAttack* attack,
                                              Creature* target, u8 hitIndex, ExecutingAttack::HitData* hitData) {
    Try(out = p->GetDamage(attack, target, hitIndex, *hitData);)
}

export u8 CreatureLib_DamageLibrary_GetBasePower(u8& out, const DamageLibrary* p, ExecutingAttack* attack,
                                                 Creature* target, u8 hitIndex, ExecutingAttack::HitData* hitData) {
    Try(out = p->GetBasePower(attack, target, hitIndex, *hitData);)
}
export u8 CreatureLib_DamageLibrary_GetStatModifier(float& out, const DamageLibrary* p, ExecutingAttack* attack,
                                                    Creature* target, u8 hitIndex, ExecutingAttack::HitData* hitData) {
    Try(out = p->GetStatModifier(attack, target, hitIndex, *hitData);)
}
export u8 CreatureLib_DamageLibrary_GetDamageModifier(float& out, const DamageLibrary* p, ExecutingAttack* attack,
                                                      Creature* target, u8 hitIndex,
                                                      ExecutingAttack::HitData* hitData) {
    Try(out = p->GetDamageModifier(attack, target, hitIndex, *hitData);)
}
